'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = combine;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _lodashArrayIntersection = require('lodash/array/intersection');

var _lodashArrayIntersection2 = _interopRequireDefault(_lodashArrayIntersection);

var _lodashArrayDifference = require('lodash/array/difference');

var _lodashArrayDifference2 = _interopRequireDefault(_lodashArrayDifference);

var _lodashObjectMerge = require('lodash/object/merge');

var _lodashObjectMerge2 = _interopRequireDefault(_lodashObjectMerge);

function mergeGetterResults(left, right) {
  if (!left) {
    return right;
  }

  if (!right) {
    return left;
  }

  if (left === right) {
    return right;
  }

  if (Array.isArray(left) && Array.isArray(right)) {
    if (left.lenght !== right.lenght) {
      throw new Error('Unable to merge two arrays with different length');
    }

    return left.map(function (l, index) {
      return mergeGetterResults(l, right[index]);
    });
  }

  if (typeof left === 'object' && typeof right === 'object') {
    var leftKeys = Object.keys(left);
    var rightKeys = Object.keys(right);

    var intersectionKeys = (0, _lodashArrayIntersection2['default'])(leftKeys, rightKeys);
    var leftDifferenceKeys = (0, _lodashArrayDifference2['default'])(leftKeys, rightKeys);
    var rightDifferenceKeys = (0, _lodashArrayDifference2['default'])(rightKeys, leftKeys);

    return (0, _lodashObjectMerge2['default'])({}, intersectionKeys.reduce(function (acc, key) {
      acc[key] = mergeGetterResults(left[key], right[key]);
      return acc;
    }, {}), leftDifferenceKeys.reduce(function (acc, key) {
      acc[key] = left[key];
      return acc;
    }, {}), rightDifferenceKeys.reduce(function (acc, key) {
      acc[key] = right[key];
      return acc;
    }, {}));
  }

  throw new Error('Unable to merge "' + JSON.stringify(left) + '" and "' + JSON.stringify(right) + '"');
}

function combine() {
  for (var _len = arguments.length, getters = Array(_len), _key = 0; _key < _len; _key++) {
    getters[_key] = arguments[_key];
  }

  return function (resource, key, follow) {
    return getters.reduce(function (result, getter) {
      return mergeGetterResults(result, getter(resource, key, follow));
    }, null) // null-reasonable
    ;
  };
}

module.exports = exports['default'];