/* @flow */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = fulfillTreeSchema;

function readResource(resources, rootLink, schema) {
  var resource = resources.filter(function (r) {
    return r.id === rootLink.id && r.type === rootLink.type;
  }).shift();

  if (!resource) {
    return;
  }

  var follow = function follow(relationshipLink, relationshipSchema) {
    return fulfillTreeSchema(resources, relationshipLink, relationshipSchema);
  };

  return schema(resource, follow);
}

function readResourceArray(resources, rootLinks, schema) {
  return rootLinks.map(function (rootLink) {
    return readResource(resources, rootLink, schema);
  });
}

function fulfillTreeSchema(resources, rootLink, schema) {
  if (Array.isArray(rootLink)) {
    return readResourceArray(resources, rootLink, schema);
  }

  if (rootLink) {
    return readResource(resources, rootLink, schema);
  }
}

module.exports = exports['default'];